#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "settings.h"


void save_settings(GtkWidget *top){

	FILE *pf;
	char settings_file[1024];

	int i;
	const gchar *home_path=g_get_home_dir();

	strcpy(settings_file, home_path);
	strcat(settings_file,"/.usokoban");

	//g_message("%s",home_path);

	pf=fopen(settings_file,"w");

	//g_message("%s",home_path);

	fprintf(pf,"levelset=%s\n",level_filename);
	fprintf(pf,"no=%d\n",c_level+1);
	for(i=0;i<4;i++) fprintf(pf,"skin%d=%s\n",i+1,skin_files[i]);

	
	fprintf(pf,"skin.default=%s\n",skin_filename);

	fprintf(pf,"window.width=%d\n",top->allocation.width);
	fprintf(pf,"window.height=%d\n",top->allocation.height);
	fprintf(pf,"window.maximized=%d\n",screen_maximized);

	fprintf(pf,"levelfolder=%s\n", level_folder);

	fprintf(pf,"\n");
	fclose(pf);
	return;
}

void init_settings(){

	level_filename=g_malloc(1024);  level_folder=g_malloc(1024); 

	strcpy(level_filename, "/usr/share/games/usokoban"); strcat(level_filename,"/stopheart.txt");
	c_level=0;
	strcpy(skin_files[0],"/usr/share/games/usokoban/skin12.png");
	strcpy(skin_files[1],"/usr/share/games/usokoban/skin18.png");
	strcpy(skin_files[2],"/usr/share/games/usokoban/skin36.png");
	strcpy(skin_files[3],"/usr/share/games/usokoban/skin54.png");
	strcpy(skin_filename,"/usr/share/games/usokoban/skin36.png");
	strcpy(level_folder, "/usr/share/games/usokoban");
				
	return;

}

//return 0 if settings file not exist
int load_settings(){

	char settings_file[1024];
	FILE *pf;
	char buffer[1024];
	int line=0;
	int i,j=0;

	const gchar *home_path=g_get_home_dir();

	
	
	strcpy(settings_file, home_path);
	strcat(settings_file,"/.usokoban");

	pf=fopen(settings_file,"r");

	if(pf==NULL) return 0;

	while(fgets(buffer,1024,pf)!=NULL){
		line++;
		switch(line){
			case 1: level_filename=g_malloc(1024); 
				//strcpy(level_filename, home_path); strcat(level_filename,"/");
				strcpy(level_filename, buffer+9);
				if(level_filename[strlen(level_filename)-1]=='\n') level_filename[strlen(level_filename)-1]='\0';
				//g_message("%s",level_filename);
				break;
			case 2:
				c_level=atoi(buffer+3)-1;
				//g_message("%d",c_level);
				break;
			case 3:
				strcpy(skin_files[0],buffer+6);
				 break;
			case 4:
				strcpy(skin_files[1],buffer+6);break;
			case 5:
				strcpy(skin_files[2],buffer+6);break;
			case 6:
				strcpy(skin_files[3],buffer+6);break;
			case 7: strcpy(skin_filename, buffer+13); break;
			case 8: 
				screen_width=atoi(buffer+13); break;
			case 9: 
				screen_height=atoi(buffer+14); break;
			case 10: 
				screen_maximized=atoi(buffer+17);
				//g_message("max=%d",screen_maximized);
				break;
			case 11: 
				level_folder=g_malloc(1024);
				strcpy(level_folder,buffer+12);
				//g_message("max=%d",screen_maximized);
				break;
		}
		
		//g_message("%s",buffer);
		

	} //end of file (while)

	for(i=0;i<4;i++){
		if(skin_files[i][strlen(skin_files[i])-1]=='\n') skin_files[i][strlen(skin_files[i])-1]='\0';
		 //g_message("%s",skin_files[i]);

	}	
	skin_filename[strlen(skin_filename)-1]='\0'; 

	level_folder[strlen(level_folder)-1]='\0'; 

	fclose(pf);

	return 1;
}

